package space.eptaproject.vmodaddon.block;

import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.util.Mth;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodaddon.IPhysicsTrackController;
import space.eptaproject.vmodaddon.Vmodaddon;

public class TBBE extends BlockEntity {
    public TBBE(BlockPos p_155229_, BlockState p_155230_) {
        super(Vmodaddon.MY_BLOCK_ENTITY.get(), p_155229_, p_155230_);
    }

    @Override
    protected void saveAdditional(CompoundTag tag) {
        super.saveAdditional(tag);
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            PhysicsTrackController controller = ship.getAttachment(PhysicsTrackController.class);
            if (controller != null) {
                tag.putFloat("SuspensionStiffness", ((IPhysicsTrackController) controller).getSuspensionStiffness());
            }
        }
    }

    @Override
    public void load(CompoundTag tag) {
        super.load(tag);

        if (tag.contains("SuspensionStiffness")) {
            ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
            if (ship != null) {
                PhysicsTrackController controller = PhysicsTrackController.getOrCreate(ship);
                ((IPhysicsTrackController) controller).setSuspensionStiffness(tag.getFloat("SuspensionStiffness"));
            }
        }
    }
}
