package space.eptaproject.vmodaddon.mixin;

import it.unimi.dsi.fastutil.objects.Object2ObjectArrayMap;

import java.util.Map;

public class InstanceHolder<T> {
    private final Map<Class<? extends T>, T> instances = new Object2ObjectArrayMap<>();

    public InstanceHolder() {

    }
    public T get(String cls) {
        try {
            return get((Class<? extends T>) Class.forName(cls));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }


    public T get(Class<? extends T> cls) {
        if (instances.containsKey(cls)) {
            return instances.get(cls);
        }

        try {
            T instance = cls.getDeclaredConstructor().newInstance();
            instances.put(cls, instance);
            return instance;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
