package space.eptaproject.vmodaddon.mixin;

import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.*;
import org.spongepowered.asm.mixin.extensibility.IMixinInfo;

import java.util.ListIterator;

public class KotlinOptimizationTransformer implements ITransformer {


    @Override
    public void transform(String targetClassName, ClassNode classNode, String mixinClassName, IMixinInfo mixinInfo) {
        for (MethodNode method : classNode.methods) {
            ListIterator<AbstractInsnNode> it = method.instructions.iterator();

            while (it.hasNext()) {
                AbstractInsnNode insn = it.next();

                if (insn.getOpcode() == Opcodes.INVOKESTATIC &&
                        insn instanceof MethodInsnNode methodInsn &&
                        methodInsn.owner.equals("kotlin/jvm/internal/Intrinsics") &&
                        (methodInsn.name.equals("checkParameterIsNotNull") || methodInsn.name.equals("checkNotNullParameter") || methodInsn.name.equals("checkNotNullExpressionValue")) &&
                        methodInsn.desc.equals("(Ljava/lang/Object;Ljava/lang/String;)V")) {

                    AbstractInsnNode arg2Insn = methodInsn.getPrevious();
                    AbstractInsnNode arg1Insn = arg2Insn != null ? arg2Insn.getPrevious() : null;

                    method.instructions.remove(arg1Insn);
                    method.instructions.remove(arg2Insn);
                    method.instructions.remove(insn);
                }
            }
        }
    }
}
