package space.eptaproject.vmodaddon.mixin;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.Type;
import org.spongepowered.asm.mixin.extensibility.IMixinConfigPlugin;
import org.spongepowered.asm.mixin.extensibility.IMixinInfo;

import org.objectweb.asm.tree.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Set;

public class MixinPlugin implements IMixinConfigPlugin {
    public InstanceHolder<ITransformer> transformerInstanceHolder = new InstanceHolder<>();

    @Override
    public void onLoad(String mixinPackage) {

    }

    @Override
    public String getRefMapperConfig() {
        return null;
    }

    @Override
    public boolean shouldApplyMixin(String targetClassName, String mixinClassName) {
        return true;
    }
    @Override
    public void acceptTargets(Set<String> myTargets, Set<String> otherTargets) {

    }

    @Override
    public List<String> getMixins() {
        return List.of(
                "BlockPaletteHashMapV1Mixin",
                "PhysicsTrackControllerAccessor",
                "PhysicsTrackControllerMixin"
        );
    }
    @Override
    public void preApply(String targetClassName, ClassNode targetClass, String mixinClassName, IMixinInfo mixinInfo) {

    }

    @Override
    public void postApply(String targetClassName, ClassNode classNode, String mixinClassName, IMixinInfo mixinInfo) {
        String annotationDesc = "Lspace/eptaproject/vmodaddon/mixin/A;";

        if (classNode.visibleAnnotations == null) {
            classNode.visibleAnnotations = new ArrayList<>();
        }

        AnnotationNode existing = null;
        for (AnnotationNode ann : classNode.visibleAnnotations) {
            if (Objects.equals(ann.desc, annotationDesc)) {
                existing = ann;
                break;
            }
        }

        if (existing != null) {
            List<Object> values = existing.values;
            for (int i = 0; i < values.size(); i += 2) {
                String key = (String) values.get(i);
                if (key.equals("value")) {
                    List<String> list = (List<String>) values.get(i + 1);
                    if (!list.contains(mixinClassName)) {
                        list.add(mixinClassName);
                    }
                    return;
                }
            }

            values.add("value");
            values.add(new ArrayList<>(List.of(mixinClassName)));
        } else {
            AnnotationNode newAnnotation = new AnnotationNode(annotationDesc);
            newAnnotation.values = new ArrayList<>();
            newAnnotation.values.add("value");
            newAnnotation.values.add(new ArrayList<>(List.of(mixinClassName)));
            classNode.visibleAnnotations.add(newAnnotation);
        }

        transformerInstanceHolder.get(KotlinOptimizationTransformer.class).transform(targetClassName, classNode, mixinClassName, mixinInfo);
    }
}